core/urls.py
from django.urls import path, include

from core import views

urlpatterns = [
    path('login/', views.LoginPage.as_view(), name = 'login'),
    path('logout/', views.LogoutPage.as_view(), name = 'logout'),
    path('', views.LandingPage.as_view(), name='landing'),
    # Admin
    path('admin-home/', views.AdminHome.as_view(), name = 'admin-home'),
    path('user/', views.CreateUser.as_view(), name = 'user'),
    path('user/<int:pk>/', views.EditUser.as_view(), name = 'edit-user'),
    path('user/<int:pk>/delete/', views.DeleteUser.as_view(), name = 'delete-user'),
]

server/urls.py
"""cerrax-cloud URL Configuration
"""
from django.contrib import admin
from django.urls import path, include
from django.shortcuts import redirect

def redirect_view(request, uri, root=''):
    return redirect(root+uri, permanent=True)

urlpatterns = [

    # admin interface !! FOR DEV ONLY - NOT PRODUCTION !!
    path('admin/', admin.site.urls),

    # main website (Cerrax.com)
    path('', include(('website.urls', 'website'), namespace='website')),

    # Cerrax Cloud apps
    path('cloud/', include(('core.urls', 'core'), namespace='core')),
    path('cloud/lister/', include(('lister.urls', 'lister'), namespace='lister')),
    path('cloud/docket/', include(('docket.urls', 'docket'), namespace='docket')),
    path('cloud/arkham/', include(('arkham.urls', 'arkham'), namespace='arkham')),
    # redirect lister, since it it used frequently
    # deprecate this path and eventually disable it
    path('lister/<path:uri>', redirect_view, {'root':'/cloud/lister/'}),
    
]

core/models.py
from django.contrib.auth.models import AbstractUser
from django.db import models

#-== @h1
# Core Models
#-== /core.models.py
#________________________________________


##########################################
#-== @class
class CoreModel(models.Model):
	#-== Abstract base model which tracks
	# when the object was created and last modified.

	# -== *Model Fields:*
	# @deflist
	# created: datetime that the model was added to the database
	# updated: datetime that the most recent change was made to the object

	created = models.DateTimeField(auto_now_add=True)
	updated = models.DateTimeField(auto_now=True)

	class Meta:
		abstract = True



##########################################
#-== @class
class Apps:
	#-== Unified list of available apps for use throughout the server code.
	# @attributes
	# ADMIN: administrative app to manage users and permissions
	# LISTER: list-making app
	# DOCKET: task tracking app
	# ARKHAM: game

	LISTER = 'lister'
	DOCKET = 'docket'
	#HEALTH = 'health'
	ARKHAM = 'arkham'

	ADMIN = 'admin' # NOTE: admin should always be at the bottom of the list!

	list = [
		{ 'display': 'Lister', 'app': LISTER, 'enabled': True, 'url': 'lister:home' },
		{ 'display': 'Docket', 'app': DOCKET, 'enabled': True, 'url': 'docket:home' },
		#{ 'display': 'Health', 'app': HEALTH, 'enabled': True, 'url': 'health:home' },
		#{ 'display': 'Game Title', 'app': ARKHAM, 'enabled': True, 'url': 'arkham:home' },
		
		# NOTE: admin should always be at the bottom of the list!
		{ 'display': 'Admin', 'app': ADMIN, 'enabled': False, 'url': 'core:admin-home' },
	]

	# ----------------------------------------------------
	#-== @method
	@classmethod
	def perms(cls):
		#-== Provides a list of apps for the
		# /AppPermissions model's /choices parameter

		perms = []
		for app in cls.list:
			perms.append((app['app'], app['display']))
		return perms



##########################################
#-== @class
class CerraxUser(AbstractUser):
	#-== Default Django /User model with additional
	# fields and methods for use with Cerrax Cloud.

	#-== *Model Fields:*
	# - _(see Django /User model: !https://docs.djangoproject.com/en/3.2/ref/contrib/auth/ )_
	
	# ----------------------------------------------------
	#-== @method
	def has_app_permission(self, perm):
		#-== Checks if the user has permission to access an app.
		# @params
		# perm: a string of the app name, typically pulled from the /Apps class

		if self.is_superuser:
			return True
		return self.apppermissions_set.filter(app=perm).exists()

	def __str__(self):
		return self.username



##########################################
#-== @class
class AppPermissions(CoreModel):
	#-== Many-to-many relationship for users and
	# the apps they have permission to use.

	#-== *Model Fields:*
	# @deflist
	# app: the app name the permission grants (derived from the /Apps class)
	# user: the /CerraxUser model which the permission belongs to

	app = models.CharField(max_length=50, choices=Apps.perms())
	user = models.ForeignKey(CerraxUser, on_delete=models.CASCADE)

	def __str__(self):
		return '{} - {}'.format(self.user, self.app)


##########################################
#-== @class
class ErrorMessage(CoreModel):
	#-== One-to-many relationship for users and
	# any unread error messages they have

	#-== *Model Fields:*
	# @deflist
	# message: the message to display
	# user: the /CerraxUser model which the permission belongs to

	message = models.CharField(max_length=1000, default="Generic server error")
	user = models.ForeignKey(CerraxUser, on_delete=models.CASCADE)

	def __str__(self):
		return '{} - {}'.format(self.user, self.message)

core/views.py
import logging
from copy import deepcopy

from django.views import View
from django.forms.models import model_to_dict
from django.core import serializers
from django.core.exceptions import ObjectDoesNotExist, ValidationError
from django.http import HttpResponse, HttpResponseRedirect, HttpResponseServerError
from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.hashers import make_password
from django.contrib.auth.mixins import LoginRequiredMixin
from django.shortcuts import render, redirect
from django.urls import reverse_lazy

from core.models import Apps, ErrorMessage, CerraxUser, AppPermissions

#-== @h1
# Core Views
#-== /core.views.py
#________________________________________


##########################################
#-== @class
class UnauthenticatedView(View):
	#-== Provides the basic elements that all pages will use.
	# See the Django /View documentation for more info:
	#						!https://docs.djangoproject.com/en/3.2/topics/class-based-views/
	# @attributes
	# titlebar_visible: a boolean that determines if the title bar is visible
	# page_title: the title displayed in the titlebar of the app, as well as the browser tab
	# back_url: the URL for the Back button in the titlebar
	# menu_visible: boolean that determines if the menu is available in the titlebar
	# button_bar_left: a list of buttons to modify the view of the page
	# button_bar_right: a list of buttons which provide additional actions on the page

	titlebar_visible = False
	page_title = 'WARN: No Title'
	back_url = None
	menu_visible = True
	button_bar_left = []
	button_bar_right = []

	# ----------------------------------------------------
	#-== @method
	def log_error(self, error_msg, exception=None):
		# -== Handles settings error messages for both
		# the HTML output and the application logs.
		# @params
		# error_msg: the message to display
		# exception: the exception which should display a stack trace in the log

		# if the error_msg is a list of error messages,
		# log each message separately
		logerrorstr = error_msg
		if isinstance(error_msg, list):
			logerrorstr = '\n'.join(error_msg)
		# if there was an exception, log the traceback as well
		if exception:
			self.logger.exception(logerrorstr)
		else:
			self.logger.error(logerrorstr)
		# add the error_msg to the 'errors' context member
		if isinstance(error_msg, list):
			self.context['errors'].extend(error_msg)
		else:
			self.context['errors'].append(error_msg)


	# ----------------------------------------------------
	#-== @method
	def setup(self, request, *args, **kwargs):
		#-== Defines the context for the template render
		# and prepares the view for dispatch.

		super().setup(request, *args, *kwargs)
		self.logger = logging.getLogger('cxcloud.{}'.format(self.__class__.__qualname__))
		self.user = request.user
		self.context = {}
		self.context['errors'] = self.get_errors()
		self.context['titlebar_visible'] = self.titlebar_visible
		self.context['page_title'] = self.page_title
		self.context['back_url'] = self.back_url
		self.context['menu_visible'] = self.menu_visible
		self.context['button_bar_left'] = self.button_bar_left
		self.context['button_bar_right'] = self.button_bar_right

	# ----------------------------------------------------
	#-== @method
	def get_errors(self, user=None):
		#-== Collect any errors from database.
		# Error messages are deleted once they
		# are loaded from the database.
		# @params
		# user: the user to get errors for.
		#		If no user is provided, the view
		#		will attempt to find messages for
		#		the currently logged in user.

		error_list = []
		if not user:
			user = self.user

		if user and not user.is_anonymous:
			# if we have a user, retrieve any messages they have
			messages = ErrorMessage.objects.filter(user=user)
			for item in messages:
				error_list.append(item.message)
			# remove the messages, since they will be displayed
			messages.delete()

		return error_list

	# ----------------------------------------------------
	#-== @method
	def check_perms(self, request, *args, **kwargs):
		#-== Check permissions of the user. As this is
		# the unauthenticated view, nothing happens here.

		pass

	# ----------------------------------------------------
	#-== @method
	def initialize(self, request, *args, **kwargs):
		#-== Do any prep work before the view is dispatched.
		# This is blank and should be overriden as needed.

		pass

	# ----------------------------------------------------
	#-== @method
	def dispatch(self, request, *args, **kwargs):
		#-== Dispatches the view with the appropriate HTTP method
		# after checking permissions and initializing.

		self.check_perms(request, *args, **kwargs)
		self.initialize(request, *args, **kwargs)
		return super().dispatch(request, *args, **kwargs)

	#-== The Django /View class allows the developer
	# to create methods for each HTTP request method type
	# ( /GET , /POST , /PUT , /PATCH, /DELETE , /OPTIONS ).
	# Any methods which are not included will
	# respond with an HTTP error 405 (Method Not Allowed).

	# ----------------------------------------------------
	def get(self, request, *args, **kwargs):
		pass

	# ----------------------------------------------------
	# def post(self, request, *args, **kwargs):
	#	pass

	# ----------------------------------------------------
	# def put(self, request, *args, **kwargs):
	# 	pass

	# ----------------------------------------------------
	# def patch(self, request, *args, **kwargs):
	# 	pass

	# ----------------------------------------------------
	# def delete(self, request, *args, **kwargs):
	# 	pass

	# ----------------------------------------------------
	# def options(self, request, *args, **kwargs):
	# 	pass

	# ----------------------------------------------------
	#-== @method
	def redirect(self, to, *args, **kwargs):
		#-== An override for django's redirect which
		# makes sure we pass errors to the database
		# so that errors will be displayed upon redirect.

		err = self.context['errors']
		if 'errors' in kwargs.keys():
			err = kwargs.pop('errors')

		if self.user and not self.user.is_anonymous:
			for message in err:
				ErrorMessage.objects.create(message=message, user=self.user)

		return redirect(to, *args, **kwargs)



##########################################
#-== @class
class BaseView(LoginRequiredMixin, UnauthenticatedView):
	#-== Adds login reuirement and permission checks to basic page.
	# @attributes
	# login_url: the URL to redirect when an unauthenticed user makes a request
	# app_permission: the app name (derived from the /core.models.Apps class)
	#					which the user must have permission to access

	login_url = 'core:login'
	app_permission = None
	titlebar_visible = True

	# ----------------------------------------------------
	#-== @method
	def check_perms(self, request, *args, **kwargs):
		#-== Checks that the /request.user has the proper permissions.
		# Raises a /PermissionDenied exception if they do not.

		if self.app_permission and not request.user.has_app_permission(self.app_permission):
				raise PermissionDenied



##########################################
#-== @class
class LoginPage(UnauthenticatedView):
	#-== Provides a simple form for authentication.

	page_title = 'Login'

	# ----------------------------------------------------
	#-== @method
	# GET
	#-== Renders the template /core\/login.html .

	def get(self, request, *args, **kwargs):
		return render(request, 'core/login.html', self.context)

	# ----------------------------------------------------
	#-== @method
	# POST
	#-== Authenticates and logs in the user.
	# Successful login redriects to the Landing page.

	def post(self, request, *args, **kwargs):
		username = request.POST['username']
		password = request.POST['password']
		user = authenticate(username=username, password=password)
		if user:
			if user.is_active:
				login(request, user)
				return self.redirect('core:landing')
			else:
				self.logger.error("Disabled user attempted to log in: '{0}'".format(username))
				self.context['errors'].append('User has been disabled.')
		else:
			self.logger.error("Invalid login details for username '{0}'".format(username))
			self.context['errors'].append('Username and/or password is incorrect.')

		return render(request, 'core/login.html', self.context)



##########################################
#-== @class
class LogoutPage(BaseView):
	#-== Logs out a user and redirects to login.

	# ----------------------------------------------------
	#-== @method
	# GET
	#-== Logs out a user and redirects to login.

	def get(self, request, *args, **kwargs):
		logout(request)
		return self.redirect('core:login')



##########################################
#-== @class
class LandingPage(BaseView):
	#-== The index of the server; provides a list of apps (based on the user's permissions).

	page_title = 'Cerrax Cloud'
	menu_visible = False

	# ----------------------------------------------------
	#-== @method
	# GET
	#-== Displays the list of apps, based on the user's permissions.
	# Renders the /core\/landing.html template.

	def get(self, request, *args, **kwargs):
		mylist = []
		for record in Apps.list:
			if record['app'] == Apps.ADMIN:
				# Admin should always be at the bottom
				continue
			if request.user.has_app_permission(record['app']):
				mylist.append(record)

		userlist = []
		if request.user.has_app_permission(Apps.ADMIN):
			userlist.append({'app': Apps.ADMIN, 'display': 'Admin', 'url': 'core:admin-home'})

		userlist.append({'display': 'Logout', 'url': 'core:logout'})

		self.context['applist'] = mylist
		self.context['userlist'] = userlist
		return render(request, 'core/landing.html', self.context)



##########################################
#-== @class
class AdminHome(BaseView):
	#-== Provides a list of users and the ability to add and edit users.

	app_permission = Apps.ADMIN
	page_title = 'Admin'
	back_url = reverse_lazy('core:landing')
	button_bar_left = [

core/templates/core/admin-home.html
{% extends 'core/base.html' %}
{% load static %}


{% block content %}
<div class="list">
	{% for user in userlist %}
	<a href="{% url 'core:edit-user' user.id %}">
		<div class="list-item">{{ user.first_name }} {{ user.last_name }}</div>
	</a>
	{% endfor %}
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</div>
{% endblock %}

core/templates/core/base.html
{% load static %}
{% load core_components %}

<!DOCTYPE html>
<html>
<head>
	<title>{{ page_title }} | Cerrax Cloud</title>
	<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1, user-scalable=no, minimal-ui">
	<link rel="stylesheet" type="text/css" href="{% static 'core/css/main.css' %}">
	<link rel="apple-touch-icon" sizes="180x180" href="{% static 'core/favicons/apple-touch-icon.png' %}">
	<link rel="shortcut icon" type="image/png" sizes="32x32" href="{% static 'core/favicons/favicon-32x32.png' %}">
	<link rel="shortcut icon" type="image/png" sizes="16x16" href="{% static 'core/favicons/favicon-16x16.png' %}">
	<link rel="manifest" href="{% static 'core/favicons/site.webmanifest' %}">
	{% block header %}
	{% endblock %}
</head>
<body>
	{% if errors %}
		<div class="error">
			{% for err in errors %}
			<div class="error-msg">{{ err }}</div>
			{% endfor %}
		</div>
	{% endif %}

	{% if titlebar_visible %}
		<div class="toolbar">
			{% if back_url %}
			<a href="{{ back_url }}">
				<div class='button'>{% icon 'keyboard_arrow_left' %}</div>
			</a>
			{% else %}
				<div class='button'></div>
			{% endif %}
			<div class='title'>{{ page_title }}</div>
			{% if menu_visible %}
			<a href="{% url 'core:landing' %}">
				<div class='button'>{% icon 'menu' %}</div>
			</a>
			{% else %}
				<div class='button'></div>
			{% endif %}
		</div>
		<div class="toolbar button_bar">
			{% for record in button_bar_left %}
			<a href="{{ record.url }}">
				<div class='button'>{{ record.display }}</div>
			</a>
			{% endfor %}
			<div class='title'></div>
			{% for record in button_bar_right %}
			<a href="{{ record.url }}">
				<div class='button'>{{ record.display }}</div>
			</a>
			{% endfor %}
		</div>
	{% endif %}
	<div class="appframe">
		<div class="list-spacer"></div>
		{% block content %}
		{% endblock %}
	</div>

</body>
</html>

core/templates/core/delete-user.html
{% extends 'core/base.html' %}
{% load static %}


{% block content %}
<div id="list">
	<form id="delete-user" method="POST">
	<label>Are you sure you want to <br/> delete this user?</label>
	<div class="delete-user-name">
		{{ user.first_name }} {{ user.last_name }}
	</div>
	<div class="delete-user-username">
		{{ user.username }}
	</div>
		{% csrf_token %}
		<input type="submit" value="Yes" class="warning-color" />
	</form>
	<div class="list padded">
		<a href="{% url 'core:admin-home' %}" class="list">
			<button>No</button>
		</a>
	</div>
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</div>
{% endblock %}

core/templates/core/landing.html
{% extends 'core/base.html' %}
{% load static %}


{% block content %}
<div class="list">
	{% for item in applist %}
	<a href="{% url item.url %}">
		<div class="list-item">{{ item.display }}</div>
	</a>
	{% endfor %}
	<div class="list-spacer"></div>
	{% for item in userlist %}
	<a href="{% url item.url %}">
		<div class="list-item">{{ item.display }}</div>
	</a>
	{% endfor %}
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</div>
{% endblock %}

core/templates/core/login.html
{% extends 'core/base.html' %}
{% load static %}


{% block content %}
<div class="login-title">Cerrax Cloud</div>
<form id="login-form" method="POST">
	{% csrf_token %}
	<label>Username</label>
	<input type="text" name="username" value="" />
	<label>Password</label>
	<input type="password" name="password" value="" />
	<input type="submit" value="Login" />
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</form>
{% endblock %}

core/templates/core/user-form.html
{% extends 'core/base.html' %}
{% load static %}


{% block content %}
<form id="user-form" method="POST">
	{% csrf_token %}
	<label>Username</label>
	<input type="text" name="username" value="{{ username }}" />

	<label>Password</label>
	<input type="password" name="password" value="{{ password }}" />

	<label>First Name</label>
	<input type="text" name="first_name" value="{{ first_name }}" />

	<label>Last Name</label>
	<input type="text" name="last_name" value="{{ last_name }}" />

	<div>App Permissions</div>

	{% for app in app_permissions %}
	<div class="checkbox-box">
		<input type="checkbox" name="{{ app.app }}" {% if app.enabled %}checked{% endif %} />
		<label>{{ app.display }}</label>
	</div>
	{% endfor %}

	<input type="submit" value="Save" />
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</form>
{% if userid %}
<div class="list padded">
	<a href="{% url 'core:delete-user' userid %}" class="list">
		<button class="warning-color">Delete User</button>
	</a>
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</div>
{% endif %}
{% endblock %}